diff -r -u squid-2.6.STABLE13/src/redirect.c new-STABLE13/src/redirect.c
--- squid-2.6.STABLE13/src/redirect.c	Sun Jul  9 01:01:12 2006
+++ new-STABLE13/src/redirect.c	Sun May 13 00:59:37 2007
@@ -38,7 +38,7 @@
 typedef struct {
     void *data;
     char *orig_url;
-    struct in_addr client_addr;
+    struct sockaddr_storage client_addr;
     const char *client_ident;
     const char *method_s;
     RH *handler;
@@ -109,7 +109,7 @@
     }
     r = cbdataAlloc(redirectStateData);
     r->orig_url = xstrdup(http->uri);
-    r->client_addr = conn->log_addr;
+    xmemcpy(&r->client_addr, &conn->log_addr, sizeof(struct sockaddr_storage));
     r->client_ident = NULL;
     if (http->request->auth_user_request)
 	r->client_ident = authenticateUserRequestUsername(http->request->auth_user_request);
@@ -128,11 +128,11 @@
     r->handler = handler;
     r->data = data;
     cbdataLock(r->data);
-    if ((fqdn = fqdncache_gethostbyaddr(r->client_addr, 0)) == NULL)
+    if ((fqdn = fqdncache_gethostbyaddr(&r->client_addr, 0)) == NULL)
 	fqdn = dash_str;
     snprintf(buf, 8192, "%s %s/%s %s %s %s\n",
 	r->orig_url,
-	inet_ntoa(r->client_addr),
+	sockaddr_ntoa(&r->client_addr),
 	fqdn,
 	r->client_ident[0] ? rfc1738_escape(r->client_ident) : dash_str,
 	r->method_s,
diff -r -u squid-2.6.STABLE13/src/send-announce.c new-STABLE13/src/send-announce.c
--- squid-2.6.STABLE13/src/send-announce.c	Thu May 25 12:36:56 2006
+++ new-STABLE13/src/send-announce.c	Sun May 13 00:59:37 2007
@@ -53,7 +53,7 @@
 {
     LOCAL_ARRAY(char, tbuf, 256);
     LOCAL_ARRAY(char, sndbuf, BUFSIZ);
-    struct sockaddr_in S;
+    struct sockaddr_storage S;
     char *host = Config.Announce.host;
     char *file = NULL;
     u_short port = Config.Announce.port;
@@ -96,9 +96,11 @@
 	}
     }
     memset(&S, '\0', sizeof(S));
-    S.sin_family = AF_INET;
-    S.sin_port = htons(port);
-    S.sin_addr = ia->in_addrs[0];
+    xmemcpy(&S, &ia->in_addrs[0], sizeof(S));
+    if (S.ss_family == AF_INET6)
+        ((struct sockaddr_in6 *)&S)->sin6_port = htons(port);
+    if (S.ss_family == AF_INET)
+        ((struct sockaddr_in *)&S)->sin_port = htons(port);
     assert(theOutIcpConnection > 0);
     x = comm_udp_sendto(theOutIcpConnection,
 	&S, sizeof(S),
diff -r -u squid-2.6.STABLE13/src/snmp_agent.c new-STABLE13/src/snmp_agent.c
--- squid-2.6.STABLE13/src/snmp_agent.c	Fri Nov 10 01:35:07 2006
+++ new-STABLE13/src/snmp_agent.c	Sun May 13 00:59:37 2007
@@ -164,7 +164,7 @@
 	laddr = oid2addr(&Var->name[LEN_SQ_MESH + 3]);
 	for (p = Config.peers; p != NULL; p = p->next, cnt++) {
 	    index++;
-	    if (p->in_addr.sin_addr.s_addr == laddr->s_addr)
+	    if (((struct sockaddr_in *)&p->in_addr)->sin_addr.s_addr == laddr->s_addr)
 		break;
 	}
 	break;
@@ -201,7 +201,7 @@
 	break;
     case MESH_PTBL_IP:
 	Answer = snmp_var_new_integer(Var->name, Var->name_length,
-	    (snint) p->in_addr.sin_addr.s_addr,
+	    (snint) ((struct sockaddr_in *)&p->in_addr)->sin_addr.s_addr,
 	    SMI_IPADDRESS);
 	break;
     case MESH_PTBL_HTTP:
diff -r -u squid-2.6.STABLE13/src/snmp_core.c new-STABLE13/src/snmp_core.c
--- squid-2.6.STABLE13/src/snmp_core.c	Wed Nov 29 08:16:48 2006
+++ new-STABLE13/src/snmp_core.c	Sun May 13 00:59:37 2007
@@ -390,17 +390,21 @@
 snmpConnectionOpen(void)
 {
     u_short port;
-    struct sockaddr_in xaddr;
+    struct sockaddr_storage xaddr;
     socklen_t len;
     int x;
 
     debug(49, 5) ("snmpConnectionOpen: Called\n");
     if ((port = Config.Port.snmp) > (u_short) 0) {
 	enter_suid();
+
+	if (Config.Addrs.snmp_incoming.ss_family == AF_INET6)
+	    ((struct sockaddr_in6 *)&Config.Addrs.snmp_incoming)->sin6_port = ntohs(port);
+	else
+	    ((struct sockaddr_in *)&Config.Addrs.snmp_incoming)->sin_port = ntohs(port);
 	theInSnmpConnection = comm_open(SOCK_DGRAM,
 	    IPPROTO_UDP,
-	    Config.Addrs.snmp_incoming,
-	    port,
+	    &Config.Addrs.snmp_incoming,
 	    COMM_NONBLOCKING,
 	    "SNMP Port");
 	leave_suid();
@@ -409,12 +413,18 @@
 	commSetSelect(theInSnmpConnection, COMM_SELECT_READ, snmpHandleUdp, NULL, 0);
 	debug(1, 1) ("Accepting SNMP messages on port %d, FD %d.\n",
 	    (int) port, theInSnmpConnection);
-	if (Config.Addrs.snmp_outgoing.s_addr != no_addr.s_addr) {
+	if ((Config.Addrs.snmp_outgoing.ss_family == AF_INET6 &&
+	    !IN6_IS_ADDR_ALLF(&(((struct sockaddr_in6 *)&Config.Addrs.snmp_outgoing)->sin6_addr))) ||
+	    (Config.Addrs.snmp_outgoing.ss_family == AF_INET &&
+	    ((struct sockaddr_in *)&Config.Addrs.snmp_outgoing)->sin_addr.s_addr != no_addr.s_addr)) {
 	    enter_suid();
+	    if (Config.Addrs.snmp_outgoing.ss_family == AF_INET6)
+		((struct sockaddr_in6 *)&Config.Addrs.snmp_outgoing)->sin6_port = ntohs(port);
+	    else
+		((struct sockaddr_in *)&Config.Addrs.snmp_outgoing)->sin_port = ntohs(port);
 	    theOutSnmpConnection = comm_open(SOCK_DGRAM,
 		IPPROTO_UDP,
-		Config.Addrs.snmp_outgoing,
-		port,
+		&Config.Addrs.snmp_outgoing,
 		COMM_NONBLOCKING,
 		"SNMP Port");
 	    leave_suid();
@@ -431,8 +441,8 @@
 	} else {
 	    theOutSnmpConnection = theInSnmpConnection;
 	}
-	memset(&theOutSNMPAddr, '\0', sizeof(struct in_addr));
-	len = sizeof(struct sockaddr_in);
+	memset(&theOutSNMPAddr, '\0', sizeof(struct sockaddr_storage));
+	len = sizeof(struct sockaddr_storage);
 	memset(&xaddr, '\0', len);
 	x = getsockname(theOutSnmpConnection,
 	    (struct sockaddr *) &xaddr, &len);
@@ -440,7 +450,7 @@
 	    debug(51, 1) ("theOutSnmpConnection FD %d: getsockname: %s\n",
 		theOutSnmpConnection, xstrerror());
 	else
-	    theOutSNMPAddr = xaddr.sin_addr;
+	    xmemcpy(&theOutSNMPAddr, &xaddr, sizeof(xaddr));
     }
 }
 
@@ -490,7 +500,7 @@
 snmpHandleUdp(int sock, void *not_used)
 {
     LOCAL_ARRAY(char, buf, SNMP_REQUEST_SIZE);
-    struct sockaddr_in from;
+    struct sockaddr_storage from;
     socklen_t from_len;
     snmp_request_t *snmp_rq;
     int len;
@@ -498,7 +508,7 @@
     debug(49, 5) ("snmpHandleUdp: Called.\n");
 
     commSetSelect(sock, COMM_SELECT_READ, snmpHandleUdp, NULL, 0);
-    from_len = sizeof(struct sockaddr_in);
+    from_len = sizeof(struct sockaddr_storage);
     memset(&from, '\0', from_len);
     memset(buf, '\0', SNMP_REQUEST_SIZE);
 
@@ -516,14 +526,14 @@
 	debug(49, 3) ("snmpHandleUdp: FD %d: received %d bytes from %s.\n",
 	    sock,
 	    len,
-	    inet_ntoa(from.sin_addr));
+	    sockaddr_ntoa(&from));
 
 	snmp_rq = xcalloc(1, sizeof(snmp_request_t));
 	snmp_rq->buf = (u_char *) buf;
 	snmp_rq->len = len;
 	snmp_rq->sock = sock;
 	snmp_rq->outbuf = xmalloc(snmp_rq->outlen = SNMP_REQUEST_SIZE);
-	xmemcpy(&snmp_rq->from, &from, sizeof(struct sockaddr_in));
+	xmemcpy(&snmp_rq->from, &from, sizeof(struct sockaddr_storage));
 	snmpDecodePacket(snmp_rq);
 	xfree(snmp_rq->outbuf);
 	xfree(snmp_rq);
@@ -551,7 +561,7 @@
     rq->session.Version = SNMP_VERSION_1;
     Community = snmp_parse(&rq->session, PDU, buf, len);
     memset(&checklist, '\0', sizeof(checklist));
-    checklist.src_addr = rq->from.sin_addr;
+    xmemcpy(&checklist.src_addr, &rq->from, SOCKLEN(&rq->from));
     checklist.snmp_community = (char *) Community;
 
     if (Community)
@@ -563,7 +573,7 @@
 	snmpConstructReponse(rq);
     } else {
 	debug(49, 1) ("Failed SNMP agent query from : %s.\n",
-	    inet_ntoa(rq->from.sin_addr));
+	    sockaddr_ntoa(&rq->from));
 	snmp_free_pdu(PDU);
     }
     if (Community)
@@ -583,7 +593,7 @@
     snmp_free_pdu(rq->PDU);
     if (RespPDU != NULL) {
 	snmp_build(&rq->session, RespPDU, rq->outbuf, &rq->outlen);
-	comm_udp_sendto(rq->sock, &rq->from, sizeof(rq->from), rq->outbuf, rq->outlen);
+	comm_udp_sendto(rq->sock, &rq->from, SOCKLEN(&rq->from), rq->outbuf, rq->outlen);
 	snmp_free_pdu(RespPDU);
     }
 }
@@ -817,24 +827,46 @@
     if (peerptr == NULL) {
 	/* Do nothing */
     } else if (*len <= current->len) {
-	instance = xmalloc(sizeof(name) * (*len + 4));
+	if (peerptr->in_addr.ss_family == AF_INET6) 
+	    instance = xmalloc(sizeof(name) * (*len + 16));
+	else
+	    instance = xmalloc(sizeof(name) * (*len + 4));
 	xmemcpy(instance, name, (sizeof(name) * *len));
-	cp = (u_char *) & (peerptr->in_addr.sin_addr.s_addr);
+	if (peerptr->in_addr.ss_family == AF_INET6) 
+		cp = (u_char *) & (((struct sockaddr_in6 *)&peerptr->in_addr)->sin6_addr.s6_addr);
+	else
+		cp = (u_char *) & (((struct sockaddr_in *)&peerptr->in_addr)->sin_addr.s_addr);
 	instance[*len] = *cp++;
 	instance[*len + 1] = *cp++;
 	instance[*len + 2] = *cp++;
 	instance[*len + 3] = *cp++;
-	*len += 4;
+	if (peerptr->in_addr.ss_family == AF_INET6) {
+	    instance[*len + 4] = *cp++;
+	    instance[*len + 5] = *cp++;
+	    instance[*len + 6] = *cp++;
+	    instance[*len + 7] = *cp++;
+	    instance[*len + 8] = *cp++;
+	    instance[*len + 9] = *cp++;
+	    instance[*len + 10] = *cp++;
+	    instance[*len + 11] = *cp++;
+	    instance[*len + 12] = *cp++;
+	    instance[*len + 13] = *cp++;
+	    instance[*len + 14] = *cp++;
+	    instance[*len + 15] = *cp++;
+	    *len += 16;
+	}
+	else
+	    *len += 4;
     } else {
 	laddr = oid2addr(&name[*len - 4]);
 	host_addr = inet_ntoa(*laddr);
 	last_addr = xstrdup(host_addr);
       skip_duplicate:
-	current_addr = inet_ntoa(peerptr->in_addr.sin_addr);
+	current_addr = sockaddr_ntoa(&peerptr->in_addr);
 	while (peerptr && strcmp(last_addr, current_addr) != 0) {
 	    peerptr = peerptr->next;
 	    if (peerptr)
-		current_addr = inet_ntoa(peerptr->in_addr.sin_addr);
+		current_addr = sockaddr_ntoa(&peerptr->in_addr);
 	}
 
 	/* Find the next peer */
@@ -843,7 +875,7 @@
 
 	/* watch out for duplicate addresses */
 	for (peerptr2 = Config.peers; peerptr && peerptr2 != peerptr; peerptr2 = peerptr2->next) {
-	    if (peerptr2->in_addr.sin_addr.s_addr == peerptr->in_addr.sin_addr.s_addr) {
+	    if (memcmp(&peerptr2->in_addr, &peerptr->in_addr, SOCKLEN(&peerptr->in_addr))) {
 		/* ouch.. there are more than one peer on this IP. Skip the second one */
 		peerptr = peerptr->next;
 		if (peerptr)
@@ -856,7 +888,23 @@
 	if (peerptr) {
 	    instance = xmalloc(sizeof(name) * (*len));
 	    xmemcpy(instance, name, (sizeof(name) * *len));
-	    cp = (u_char *) & (peerptr->in_addr.sin_addr.s_addr);
+	    if (peerptr->in_addr.ss_family == AF_INET6)  {
+		cp = (u_char *) & (((struct sockaddr_in6 *)&peerptr->in_addr)->sin6_addr.s6_addr);
+		instance[*len - 16] = *cp++;
+		instance[*len - 15] = *cp++;
+		instance[*len - 14] = *cp++;
+		instance[*len - 13] = *cp++;
+		instance[*len - 12] = *cp++;
+		instance[*len - 11] = *cp++;
+		instance[*len - 10] = *cp++;
+		instance[*len - 9] = *cp++;
+		instance[*len - 8] = *cp++;
+		instance[*len - 7] = *cp++;
+		instance[*len - 6] = *cp++;
+		instance[*len - 5] = *cp++;
+	    }
+	    else 
+		cp = (u_char *) & (((struct sockaddr_in *)&peerptr->in_addr)->sin_addr.s_addr);
 	    instance[*len - 4] = *cp++;
 	    instance[*len - 3] = *cp++;
 	    instance[*len - 2] = *cp++;
diff -r -u squid-2.6.STABLE13/src/ssl.c new-STABLE13/src/ssl.c
--- squid-2.6.STABLE13/src/ssl.c	Sun Feb  4 06:53:38 2007
+++ new-STABLE13/src/ssl.c	Sun May 13 00:59:37 2007
@@ -36,6 +36,8 @@
 #include "squid.h"
 
 typedef struct {
+    hash_link hash;		/* dummy, must be first */
+    int ia_cur;
     char *url;
     char *host;			/* either request->host or proxy host */
     u_short port;
@@ -407,6 +409,30 @@
 
 
 static void
+sslConnectTimeout(int fd, void *data)
+{
+    SslStateData *sslState = data;
+    request_t *request = sslState->request;
+    ErrorState *err = NULL;
+    if (sslState->servers->peer)
+	hierarchyNote(&sslState->request->hier, sslState->servers->code,
+	    sslState->servers->peer->name);
+    else if (Config.onoff.log_ip_on_direct)
+	hierarchyNote(&sslState->request->hier, sslState->servers->code,
+	    fd_table[sslState->server.fd].ipaddr);
+    else
+	hierarchyNote(&sslState->request->hier, sslState->servers->code,
+	    sslState->host);
+    comm_close(fd);
+    err = errorCon(ERR_CONNECT_FAIL, HTTP_SERVICE_UNAVAILABLE, request);
+    *sslState->status_ptr = HTTP_SERVICE_UNAVAILABLE;
+    err->xerrno = ETIMEDOUT;
+    err->callback = sslErrorComplete;
+    err->callback_data = sslState;
+    errorSend(sslState->client.fd, err);
+}
+
+static void
 sslConnectDone(int fd, int status, void *data)
 {
     SslStateData *sslState = data;
@@ -430,6 +456,49 @@
 	err->callback = sslErrorComplete;
 	err->callback_data = sslState;
 	errorSend(sslState->client.fd, err);
+    } else if (status == COMM_ERR_INV_ARGS) {
+	int newsock;
+	struct sockaddr_storage cursockaddr, newsockaddr;
+	socklen_t cursocklen = sizeof(cursockaddr);
+
+	getsockname(fd, (struct sockaddr *)&cursockaddr, &cursocklen);
+	memset(&newsockaddr, '\0', sizeof(newsockaddr));
+	if (cursockaddr.ss_family == AF_INET6)
+	    newsockaddr.ss_family = AF_INET;
+	else
+	    newsockaddr.ss_family = AF_INET6;
+	newsock = comm_openex(SOCK_STREAM,
+		IPPROTO_TCP,
+		&newsockaddr,
+		COMM_NONBLOCKING,
+		0,
+		sslState->url);
+	if (newsock == COMM_ERROR) {
+	    debug(26, 4) ("sslStart: Failed because we're out of sockets.\n");
+	    err = errorCon(ERR_SOCKET_FAILURE, HTTP_INTERNAL_SERVER_ERROR, request);
+	    err->xerrno = errno;
+	    err->callback = sslErrorComplete;
+	    err->callback_data = sslState;
+	    errorSend(sslState->client.fd, err);
+	    return;
+	}
+	comm_remove_close_handler(sslState->server.fd,
+		sslServerClosed,
+		sslState);
+	comm_close(sslState->server.fd);
+	sslState->server.fd = newsock;
+	comm_add_close_handler(sslState->server.fd,
+		sslServerClosed,
+		sslState);
+	sslSetSelect(sslState);
+	commSetTimeout(sslState->server.fd,
+		Config.Timeout.connect,
+		sslConnectTimeout,
+		sslState);
+	commConnectStart(sslState->server.fd,
+		sslState->host, sslState->port,
+		sslConnectDone,
+		sslState);
     } else if (status != COMM_OK) {
 	comm_close(fd);
 	err = errorCon(ERR_CONNECT_FAIL, HTTP_SERVICE_UNAVAILABLE, request);
@@ -454,30 +523,6 @@
     }
 }
 
-static void
-sslConnectTimeout(int fd, void *data)
-{
-    SslStateData *sslState = data;
-    request_t *request = sslState->request;
-    ErrorState *err = NULL;
-    if (sslState->servers->peer)
-	hierarchyNote(&sslState->request->hier, sslState->servers->code,
-	    sslState->servers->peer->name);
-    else if (Config.onoff.log_ip_on_direct)
-	hierarchyNote(&sslState->request->hier, sslState->servers->code,
-	    fd_table[sslState->server.fd].ipaddr);
-    else
-	hierarchyNote(&sslState->request->hier, sslState->servers->code,
-	    sslState->host);
-    comm_close(fd);
-    err = errorCon(ERR_CONNECT_FAIL, HTTP_SERVICE_UNAVAILABLE, request);
-    *sslState->status_ptr = HTTP_SERVICE_UNAVAILABLE;
-    err->xerrno = ETIMEDOUT;
-    err->callback = sslErrorComplete;
-    err->callback_data = sslState;
-    errorSend(sslState->client.fd, err);
-}
-
 CBDATA_TYPE(SslStateData);
 void
 sslStart(clientHttpRequest * http, squid_off_t * size_ptr, int *status_ptr)
@@ -491,18 +536,22 @@
     int fd = http->conn->fd;
     request_t *request = http->request;
     char *url = http->uri;
+    struct sockaddr_storage addr;
     /*
      * client_addr == no_addr indicates this is an "internal" request
      * from peer_digest.c, asn.c, netdb.c, etc and should always
      * be allowed.  yuck, I know.
      */
-    if (request->client_addr.s_addr != no_addr.s_addr) {
+    if ( ((request->client_addr.ss_family == AF_INET6) &&
+	!IN6_IS_ADDR_ALLF(&((struct sockaddr_in6 *)&request->client_addr)->sin6_addr)) ||
+	((request->client_addr.ss_family == AF_INET) &&
+	(((struct sockaddr_in *)&request->client_addr)->sin_addr.s_addr != no_addr.s_addr))) {
 	/*
 	 * Check if this host is allowed to fetch MISSES from us (miss_access)
 	 */
 	memset(&ch, '\0', sizeof(aclCheck_t));
-	ch.src_addr = request->client_addr;
-	ch.my_addr = request->my_addr;
+	xmemcpy(&ch.src_addr, &request->client_addr, sizeof(ch.src_addr));
+	xmemcpy(&ch.my_addr, &request->my_addr, sizeof(ch.my_addr));
 	ch.my_port = request->my_port;
 	ch.request = request;
 	answer = aclCheckFast(Config.accessList.miss, &ch);
@@ -518,12 +567,13 @@
     statCounter.server.all.requests++;
     statCounter.server.other.requests++;
     /* Create socket. */
+    memset(&addr, '\0', sizeof(addr));
+    addr.ss_family = AF_INET;
     sock = comm_openex(SOCK_STREAM,
 	IPPROTO_TCP,
-	getOutgoingAddr(request),
-	0,
+	&addr,
 	COMM_NONBLOCKING,
-	getOutgoingTOS(request),
+	0,
 	url);
     if (sock == COMM_ERROR) {
 	debug(26, 4) ("sslStart: Failed because we're out of sockets.\n");
@@ -549,6 +599,7 @@
     sslState->client.buf = xmalloc(SQUID_TCP_SO_RCVBUF);
     /* Copy any pending data from the client connection */
     sslState->client.len = http->conn->in.offset;
+    sslState->ia_cur = -1;
     if (sslState->client.len > 0) {
 	if (sslState->client.len > SQUID_TCP_SO_RCVBUF) {
 	    safe_free(sslState->client.buf);
@@ -607,9 +658,13 @@
 static void
 sslPeerSelectComplete(FwdServer * fs, void *data)
 {
+    struct sockaddr_storage sslsock, cursockaddr;
+    ErrorState *err = NULL;
+    int newsock = -1;
     SslStateData *sslState = data;
     request_t *request = sslState->request;
     peer *g = NULL;
+    socklen_t cursocklen = sizeof(cursockaddr);
     if (fs == NULL) {
 	ErrorState *err;
 	err = errorCon(ERR_CANNOT_FORWARD, HTTP_SERVICE_UNAVAILABLE, sslState->request);
@@ -621,6 +676,13 @@
     }
     sslState->servers = fs;
     sslState->host = fs->peer ? fs->peer->host : request->host;
+    if (fs->peer) 
+	xmemcpy(&sslsock, &fs->peer->in_addr, sizeof(struct sockaddr_storage));
+    else
+	memset(&sslsock, '\0', sizeof(struct sockaddr_storage));
+/*
+	xmemcpy(&sslsock, &request->client_addr, sizeof(struct sockaddr_storage));
+*/
     if (fs->peer == NULL) {
 	sslState->port = request->port;
     } else if (fs->peer->http_port != 0) {
@@ -644,13 +706,44 @@
 	sslState->delay_id = 0;
     }
 #endif
+    if (sslsock.ss_family == AF_INET6)
+	((struct sockaddr_in6 *)&sslsock)->sin6_port = sslState->port;
+    else
+	((struct sockaddr_in *)&sslsock)->sin_port = sslState->port;
+    getsockname(sslState->server.fd, (struct sockaddr *)&cursockaddr, &cursocklen);
+    if (!sslState->host && cursockaddr.ss_family != sslsock.ss_family) {
+    memset(&cursockaddr, '\0', sizeof(cursockaddr));
+    cursockaddr.ss_family = sslsock.ss_family;
+    newsock = comm_openex(SOCK_STREAM,
+	IPPROTO_TCP,
+	&cursockaddr,
+	COMM_NONBLOCKING,
+	0,
+	sslState->url);
+    if (newsock == COMM_ERROR) {
+	debug(26, 4) ("sslStart: Failed because we're out of sockets.\n");
+	err = errorCon(ERR_SOCKET_FAILURE, HTTP_INTERNAL_SERVER_ERROR, request);
+	err->xerrno = errno;
+	errorSend(sslState->client.fd, err);
+	return;
+    }
+    comm_remove_close_handler(sslState->server.fd,
+	sslServerClosed,
+	sslState);
+    comm_close(sslState->server.fd);
+
+    sslState->server.fd = newsock;
+    comm_add_close_handler(sslState->server.fd,
+	sslServerClosed,
+	sslState);
+    sslSetSelect(sslState);
+    }
     commSetTimeout(sslState->server.fd,
 	Config.Timeout.connect,
 	sslConnectTimeout,
 	sslState);
     commConnectStart(sslState->server.fd,
-	sslState->host,
-	sslState->port,
+	sslState->host, sslState->port,
 	sslConnectDone,
 	sslState);
 }
diff -r -u squid-2.6.STABLE13/src/stat.c new-STABLE13/src/stat.c
--- squid-2.6.STABLE13/src/stat.c	Thu Nov  2 05:58:52 2006
+++ new-STABLE13/src/stat.c	Sun May 13 00:59:37 2007
@@ -1469,6 +1469,7 @@
     ConnStateData *conn;
     StoreEntry *e;
     int fd;
+    char host[100], port[8];
     for (i = ClientActiveRequests.head; i; i = i->next) {
 	const char *p = NULL;
 	http = i->data;
@@ -1482,12 +1483,12 @@
 	    storeAppendPrintf(s, "\tFD desc: %s\n", fd_table[fd].desc);
 	    storeAppendPrintf(s, "\tin: buf %p, offset %ld, size %ld\n",
 		conn->in.buf, (long int) conn->in.offset, (long int) conn->in.size);
-	    storeAppendPrintf(s, "\tpeer: %s:%d\n",
-		inet_ntoa(conn->peer.sin_addr),
-		ntohs(conn->peer.sin_port));
-	    storeAppendPrintf(s, "\tme: %s:%d\n",
-		inet_ntoa(conn->me.sin_addr),
-		ntohs(conn->me.sin_port));
+	    getnameinfo(&conn->peer, sizeof(struct sockaddr_storage),
+		host, 100, port, 8, NI_NUMERICHOST|NI_NUMERICSERV);
+	    storeAppendPrintf(s, "\tpeer: %s:%s\n", host, port);
+	    getnameinfo(&conn->me, sizeof(struct sockaddr_storage),
+		host, 100, port, 8, NI_NUMERICHOST|NI_NUMERICSERV);
+	    storeAppendPrintf(s, "\tme: %s:%s\n", host, port);
 	    storeAppendPrintf(s, "\tnrequests: %d\n",
 		conn->nrequests);
 	    storeAppendPrintf(s, "\tdefer: n %d, until %ld\n",
diff -r -u squid-2.6.STABLE13/src/structs.h new-STABLE13/src/structs.h
--- squid-2.6.STABLE13/src/structs.h	Fri Apr 27 08:11:51 2007
+++ new-STABLE13/src/structs.h	Sun May 13 00:59:37 2007
@@ -72,9 +72,9 @@
 };
 
 struct _acl_ip_data {
-    struct in_addr addr1;	/* if addr2 non-zero then its a range */
-    struct in_addr addr2;
-    struct in_addr mask;
+    struct sockaddr_storage addr1;	/* if addr2 non-zero then its a range */
+    struct sockaddr_storage addr2;
+    int masklen;
     acl_ip_data *next;		/* used for parsing, not for storing */
 };
 
@@ -114,7 +114,7 @@
 struct _auth_user_ip_t {
     dlink_node node;
     /* IP addr this user authenticated from */
-    struct in_addr ipaddr;
+    struct sockaddr_storage ipaddr;
     time_t ip_expiretime;
 };
 
@@ -254,7 +254,7 @@
     int sock;
     long reqid;
     int outlen;
-    struct sockaddr_in from;
+    struct in_addr from;
     struct snmp_pdu *PDU;
     aclCheck_t *acl_checklist;
     u_char *community;
@@ -287,7 +287,7 @@
 struct _acl_address {
     acl_address *next;
     acl_list *acl_list;
-    struct in_addr addr;
+    struct sockaddr_storage addr;
 };
 
 struct _acl_tos {
@@ -298,9 +298,9 @@
 
 struct _aclCheck_t {
     const acl_access *access_list;
-    struct in_addr src_addr;
-    struct in_addr dst_addr;
-    struct in_addr my_addr;
+    struct sockaddr_storage src_addr;
+    struct sockaddr_storage dst_addr;
+    struct sockaddr_storage my_addr;
     unsigned short my_port;
     request_t *request;
     /* for acls that look at reply data */
@@ -351,14 +351,14 @@
     unsigned int internal:1;
 };
 
-struct _sockaddr_in_list {
-    struct sockaddr_in s;
-    sockaddr_in_list *next;
+struct _sockaddr_storage_list {
+    struct sockaddr_storage s;
+    sockaddr_storage_list *next;
 };
 
 struct _http_port_list {
     http_port_list *next;
-    struct sockaddr_in s;
+    struct sockaddr_storage s;
     char *protocol;		/* protocol name */
     char *name;			/* visible name */
     char *defaultsite;		/* default web site */
@@ -496,15 +496,15 @@
 #endif
 #if USE_WCCP
     struct {
-	struct in_addr router;
-	struct in_addr address;
+	struct sockaddr_storage router;
+	struct sockaddr_storage address;
 	int version;
     } Wccp;
 #endif
 #if USE_WCCPv2
     struct {
-	sockaddr_in_list *router;
-	struct in_addr address;
+	sockaddr_storage_list *router;
+	struct sockaddr_storage address;
 	int forwarding_method;
 	int return_method;
 	int assignment_method;
@@ -585,13 +585,17 @@
 	u_short port;
     } Announce;
     struct {
-	struct in_addr udp_incoming;
-	struct in_addr udp_outgoing;
+	struct sockaddr_storage udp_incoming;
+	struct sockaddr_storage udp_outgoing;
 #if SQUID_SNMP
-	struct in_addr snmp_incoming;
-	struct in_addr snmp_outgoing;
+	struct sockaddr_storage snmp_incoming;
+	struct sockaddr_storage snmp_outgoing;
 #endif
-	struct in_addr client_netmask;
+	struct sockaddr_storage client_netmask;
+	struct sockaddr_storage udp6_incoming;
+	struct sockaddr_storage udp6_outgoing;
+	int client_masklen;
+	int client6_masklen;
     } Addrs;
     squid_off_t tcpRcvBufsz;
     squid_off_t udpMaxHitObjsz;
@@ -760,7 +764,7 @@
     squid_off_t rangeOffsetLimit;
 #if MULTICAST_MISS_STREAM
     struct {
-	struct in_addr addr;
+	struct sockaddr_storage addr;
 	int ttl;
 	unsigned short port;
 	char *encode_key;
@@ -869,9 +873,9 @@
     unsigned int type;
     u_short local_port;
     u_short remote_port;
-    struct in_addr local_addr;
+    struct sockaddr_storage local_addr;
     unsigned char tos;
-    char ipaddr[16];		/* dotted decimal address of peer */
+    char ipaddr[80];		/* dotted decimal address of peer */
     char desc[FD_DESC_SZ];
     struct {
 	unsigned int open:1;
@@ -1115,7 +1119,7 @@
 };
 
 struct _icpUdpData {
-    struct sockaddr_in address;
+    struct sockaddr_storage address;
     void *msg;
     size_t len;
     icpUdpData *next;
@@ -1162,7 +1166,7 @@
 	icp_opcode opcode;
     } icp;
     struct {
-	struct in_addr caddr;
+	struct sockaddr_storage caddr;
 	squid_off_t size;
 	size_t rq_size;
 	log_type code;
@@ -1260,9 +1264,9 @@
     /* the user details for connection based authentication */
     auth_user_request_t *auth_user_request;
     dlink_list reqs;
-    struct sockaddr_in peer;
-    struct sockaddr_in me;
-    struct in_addr log_addr;
+    struct sockaddr_storage peer;
+    struct sockaddr_storage me;
+    struct sockaddr_storage log_addr;
     char rfc931[USER_IDENT_SZ];
     int nrequests;
     struct {
@@ -1282,11 +1286,13 @@
 };
 
 struct _ipcache_addrs {
-    struct in_addr *in_addrs;
+    struct sockaddr_storage *in_addrs;
     unsigned char *bad_mask;
     unsigned char count;
+    unsigned char count6;
     unsigned char cur;
     unsigned char badcount;
+    unsigned char badcount6;
 };
 
 struct _domain_ping {
@@ -1382,10 +1388,12 @@
 #endif
 
 struct _peer {
+    hash_link hash; /* dummy, must be first */
+    int ia_cur;
     char *name;
     char *host;
     peer_t type;
-    struct sockaddr_in in_addr;
+    struct sockaddr_storage in_addr;
     struct {
 	int pings_sent;
 	int pings_acked;
@@ -1459,7 +1467,7 @@
     char *digest_url;
 #endif
     int tcp_up;			/* 0 if a connect() fails */
-    struct in_addr addresses[10];
+    struct sockaddr_storage addresses[10];
     int n_addresses;
     int rr_count;
     int rr_lastcount;
@@ -1553,14 +1561,14 @@
     void *callback_data;
     FwdServer *servers;
     /*
-     * Why are these struct sockaddr_in instead of peer *?  Because a
+     * Why are these struct sockaddr_storage instead of peer *?  Because a
      * peer structure can become invalid during the peer selection
      * phase, specifically after a reconfigure.  Thus we need to lookup
      * the peer * based on the address when we are finally ready to
      * reference the peer structure.
      */
-    struct sockaddr_in first_parent_miss;
-    struct sockaddr_in closest_parent_miss;
+    struct sockaddr_storage first_parent_miss;
+    struct sockaddr_storage closest_parent_miss;
     /*
      * ->hit and ->secho can be peer* because they should only be
      * accessed during the thread when they are set
@@ -1576,14 +1584,14 @@
 
 #if USE_ICMP
 struct _pingerEchoData {
-    struct in_addr to;
+    struct sockaddr_storage to;
     unsigned char opcode;
     int psize;
     char payload[PINGER_PAYLOAD_SZ];
 };
 
 struct _pingerReplyData {
-    struct in_addr from;
+    struct sockaddr_storage from;
     unsigned char opcode;
     int rtt;
     int hops;
@@ -1600,7 +1608,7 @@
     u_num32 reqnum;		/* req number (req'd for UDP) */
     u_num32 flags;
     u_num32 pad;
-    u_num32 shostid;		/* sender host id */
+    struct sockaddr_storage shostid;		/* sender host id */
 };
 
 struct _iostats {
@@ -1885,11 +1893,11 @@
     int max_forwards;
     /* these in_addr's could probably be sockaddr_in's */
     unsigned short client_port;
-    struct in_addr client_addr;
+    struct sockaddr_storage client_addr;
 #if FOLLOW_X_FORWARDED_FOR
-    struct in_addr indirect_client_addr;	/* after following X-Forwarded-For */
+    struct sockaddr_storage indirect_client_addr;	/* after following X-Forwarded-For */
 #endif				/* FOLLOW_X_FORWARDED_FOR */
-    struct in_addr my_addr;
+    struct sockaddr_storage my_addr;
     unsigned short my_port;
     HttpHeader header;
     squid_off_t content_length;
@@ -1956,7 +1964,7 @@
     int xerrno;
     char *dnsserver_msg;
     time_t ttl;
-    struct in_addr src_addr;
+    struct sockaddr_storage src_addr;
     char *redirect_url;
     ERCB *callback;
     void *callback_data;
@@ -2197,7 +2205,7 @@
 
 struct _ClientInfo {
     hash_link hash;		/* must be first */
-    struct in_addr addr;
+    struct sockaddr_storage addr;
     struct {
 	int result_hist[LOG_TYPE_MAX];
 	int n_requests;
@@ -2231,11 +2239,15 @@
 };
 
 struct _FwdState {
+    hash_link hash;	/* dummy, must be first */
+    int ia_cur;
     int client_fd;		/* XXX unnecessary */
     StoreEntry *entry;
     request_t *request;
     FwdServer *servers;
     int server_fd;
+    int server_fd_was_v6;
+    int server_fd_was_inv_args;
     ErrorState *err;
     time_t start;
     int n_tries;
@@ -2248,7 +2260,7 @@
 	unsigned int ftp_pasv_failed:1;
     } flags;
 #if LINUX_NETFILTER
-    struct sockaddr_in src;
+    struct sockaddr_storage src;
 #endif
 };
 
diff -r -u squid-2.6.STABLE13/src/tools.c new-STABLE13/src/tools.c
--- squid-2.6.STABLE13/src/tools.c	Sun Nov  5 02:09:45 2006
+++ new-STABLE13/src/tools.c	Sun May 13 00:59:37 2007
@@ -499,10 +499,10 @@
     host[0] = '\0';
     memcpy(&sa, &any_addr, sizeof(sa));
     if (Config.Sockaddr.http && sa.s_addr == any_addr.s_addr)
-	memcpy(&sa, &Config.Sockaddr.http->s.sin_addr, sizeof(sa));
+	memcpy(&sa, &((struct sockaddr_in *)&Config.Sockaddr.http->s)->sin_addr, sizeof(sa));
 #if USE_SSL
     if (Config.Sockaddr.https && sa.s_addr == any_addr.s_addr)
-	memcpy(&sa, &Config.Sockaddr.https->http.s.sin_addr, sizeof(sa));
+	memcpy(&sa, &((struct sockaddr_in *)&Config.Sockaddr.https->http.s)->sin_addr, sizeof(sa));
 #endif
     /*
      * If the first http_port address has a specific address, try a
@@ -1296,10 +1296,10 @@
 getMyPort(void)
 {
     if (Config.Sockaddr.http)
-	return ntohs(Config.Sockaddr.http->s.sin_port);
+	return ntohs(((struct sockaddr_in *)&Config.Sockaddr.http->s)->sin_port);
 #if USE_SSL
     if (Config.Sockaddr.https)
-	return ntohs(Config.Sockaddr.https->http.s.sin_port);
+	return ntohs(((struct sockaddr_in *)&Config.Sockaddr.https->http.s)->sin_port);
 #endif
     fatal("No port defined");
     return 0;			/* NOT REACHED */
@@ -1345,4 +1345,16 @@
 	}
     }
 #endif
+}
+
+char *
+sockaddr_ntoa(struct sockaddr *addr)
+{
+    static char host[100];
+    char *stopchar;
+    memset(host, '\0', 100);
+    getnameinfo(addr, SOCKLEN(addr), host, 100, NULL, 0, NI_NUMERICHOST);
+    if ((stopchar = strchr(host, '%')))
+	*stopchar = '\0';
+    return host;
 }
diff -r -u squid-2.6.STABLE13/src/typedefs.h new-STABLE13/src/typedefs.h
--- squid-2.6.STABLE13/src/typedefs.h	Sat Sep  2 23:08:42 2006
+++ new-STABLE13/src/typedefs.h	Sun May 13 00:59:37 2007
@@ -108,7 +108,7 @@
 typedef struct _intrange intrange;
 typedef struct _ushortlist ushortlist;
 typedef struct _relist relist;
-typedef struct _sockaddr_in_list sockaddr_in_list;
+typedef struct _sockaddr_storage_list sockaddr_storage_list;
 typedef struct _http_port_list http_port_list;
 typedef struct _https_port_list https_port_list;
 typedef struct _SquidConfig SquidConfig;
